# Requirements
All of requirements are included in requirements.txt and can be installed as
```bash
pip install -r requirements.txt
```

 

We use IPython 7.7.0  on Ubuntsu 18.04 environment.

  
------------------------------------
# Create Dataset
When you run the script 'MNIST.sh', dataset is automatically downloaded in the same directory.

# Run Experiments 


Execution code is "vae_tfcoding_MNIST.py". Run the script 'MNIST.sh' to train model and statical analysis.   
```bash
sh MNIST.sh
```

In MNIST.sh, two parameters are set as
lambda=2000
z=32

and

lambda=10000
z=256

You can try other parameters by editting them.

Then, the result will be created in the directory "MNIST_result/z${z}_lambda${lambda}".  

In the directory, the following statictics csv files are generated.

- VAE_rec__dist_z${z-1}_s_hakohige_delta0.01.csv: Statics file.  
	- column 1:  The averge of D'(z_j). D'(z_j) is a partial derivertive of dx_/dzj  
	- column 2:  The standard deviation of D'(z_j)
- VAE_rec__dist_z${z-1}_s_hakohige_delta0.01_with_sigma.csv: Statics file.  
	- column 1:  The averge of {\sigma}_j^{-2} D'(z_j).  By multipling 2{\lambda} to the first column, they become close to 1. 
	- column 2:  The standard deviation of {\sigma}_j^{-2} D'(z_j).  By multipling 2{\lambda} to the first column, their scale is the same as the estimated norm.
- VAE_variance_df_.csv: The variance of {\z_j}. 
- VAE_variance_df_inv_sigma2_.csv: The average of {\sigma_j}^{-2}


  